let tags = [| "B"; "EM"; "I"; "PL"; "S"; "TT"; "U"; "0"; "1"; "2"; "3"; "4"; "5"; "6"; "7"; "8"; "9"; "r"; "g"; "b"; "c"; "m"; "y"; "k"; "w" |]
let texts = [| ""; " "; "\n"; "Programm"; "im"; "Kopf"; "der"; "Mensch"; "wenn"; "man"; "das"; "sieht"; "wird"; "eine"; "Funktion"; "aufgerufen"; "das"; "man"; "vorsichtig"; "sein"; "muss" |]

let increaser = ref 0.0001

let rec exprint thold taglist =
  if (Random.float 100.0) < thold then
    tagremove (thold +. !increaser) taglist
  else
    tagadd (thold +. !increaser) taglist
and tagremove thold = function
    tag :: rest -> print_string ("</" ^ tag ^ ">"); dotext thold rest;
  |   [] -> exit 0;
and tagadd thold taglist =
  let tag = tags.((Random.int (Array.length tags)))
  in
  print_string ("<" ^ tag ^ ">");
  dotext thold (tag :: taglist)
and dotext thold taglist =
  print_string texts.((Random.int (Array.length texts)));
  exprint thold taglist

let main () =
  Random.self_init ();
  try
    increaser := Random.float (float_of_string Sys.argv.(1));
    exprint 1.0 []
  with _ -> 
    print_string "usage: exgen <float> # smaller float gives bigger file\n";
;;
main ()

