type color = Red | Green | Blue | Cyan | Magenta | Yellow | Black | White
and tag =
    B_tag
  | EM_tag
  | I_tag
  | PL_tag
  | S_tag
  | TT_tag
  | U_tag
  | Size_tag of int
  | Color_tag of color
and token =
    Text_token of string
  | WS_token of string
  | Open_token of tag
  | Close_token of tag
  | EOF
val colorToString : color -> string
val tagToString : tag -> string
val opentagToString : tag -> string
val closetagToString : tag -> string
val print_tok : token -> unit
val emitToken : token -> unit
val tagIsSize : tag -> bool
