open List

let unitM a succ_cont fail_cont = succ_cont a fail_cont
let failM _succ_cont fail_cont = fail_cont ()

let (>>=) = fun f1 f2 -> fun succ_cont fail_cont ->
  f1 (fun a fail_cont' -> f2 a succ_cont fail_cont') fail_cont

let (>>) = fun m k -> m >>= fun _ -> k	     (* may be dangerous (in ML) *)

let (|||) = fun f1 f2 -> fun succ_cont fail_cont ->
  f1 () succ_cont (fun _ -> f2 () succ_cont fail_cont)

let posAssertM = function true -> unitM () | false -> failM

let onceM fM a succ_cont fail_cont =
  fM a (fun a _ -> succ_cont a fail_cont) fail_cont

let runM fM a =
  fM a (fun a _ -> Some a) (fun _ -> None)
