type treenode =
    Text of string
  | WhiteSpace of string
  | Node of bool * Lexer_types.tag list * treenode list
val emitTreeM : treenode -> (unit -> 'a) -> 'a
val emitTree : treenode -> unit

val treenode_to_nodelist : treenode -> treenode list

val buildtree : Lexer_types.token list -> treenode
