


(* list_butlast [1;2;3] ==> (3,[1;2]) *)
let list_butlast xs = 
  let rec loop' bag = function
    | []  -> failwith "list_butlast"
    | [x] -> (x, List.rev bag)
    | x::xs -> loop' (x::bag) xs
  in loop' [] xs

(*
###

let list_last = function
  | [] -> None
  | x::xs -> 
      let rec list_last' el = function 
	| [] -> Some el
	| x::xs -> list_last' x xs 
      in list_last' x xs
###
*)

let rec iterrev f = function
  | [] -> ()
  | x::xs -> iterrev f xs; f x

let optionToList = function
  | Some a -> [a]
  | None -> []

let return x = x

let get1of4 (x,_,_,_) = x
let get2of4 (_,x,_,_) = x
let get3of4 (_,_,x,_) = x
let get4of4 (_,_,_,x) = x

let repl1of4 x (_,a,b,c) = (x,a,b,c)
let repl2of4 x (a,_,b,c) = (a,x,b,c)
let repl3of4 x (a,b,_,c) = (a,b,x,c)
let repl4of4 x (a,b,c,_) = (a,b,c,x)
